unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, StdCtrls, shellapi,
  WSocket, WinSock, ComCtrls;

type
  TformMenuPrincipal = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    txtIPDestinatario: TEdit;
    txtPuerto: TEdit;
    txtChat: TMemo;
    txtTexto: TMemo;
    LWEB: TLabel;
    bEnviar: TButton;
    wSocketEnviar: TWSocket;
    wSocketLeer: TWSocket;
    be: TStatusBar;
    bActivarLeer: TButton;
    bPararLeer: TButton;
    txtNick: TEdit;
    Label3: TLabel;
    procedure LWEBClick(Sender: TObject);
    procedure bEnviarClick(Sender: TObject);
    procedure wSocketEnviarDataSent(Sender: TObject; ErrCode: Word);
    procedure wSocketLeerDataAvailable(
        Sender: TObject; ErrCode: Word);
    procedure wSocketLeerSessionConnected(
        Sender: TObject; ErrCode: Word);
    procedure wSocketLeerSessionClosed(
        Sender: TObject; ErrCode: Word);
    procedure bActivarLeerClick(Sender: TObject);
    procedure bPararLeerClick(Sender: TObject);
    procedure wSocketEnviarError(Sender: TObject);
    procedure wSocketEnviarSessionConnected(Sender: TObject;
      ErrCode: Word);
  private
    { Private declarations }
    FSenderAddr    : TInAddr;
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

function atoi(value : string) : Integer;
var
  i : Integer;
begin
  Result := 0;
  i := 1;
  while (i <= Length(Value)) and (Value[i] = ' ') do
    i := i + 1;
  while (i <= Length(Value)) and (Value[i] in ['0'..'9']) do
  begin
    Result := Result * 10 + ord(Value[i]) - ord('0');
    i := i + 1;
  end;
end;


procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.bEnviarClick(Sender: TObject);
begin
  wSocketEnviar.Proto := 'udp';
  wSocketEnviar.Addr := txtIPDestinatario.Text;
  wSocketEnviar.Port := txtPuerto.Text;
  //wSocketEnviar.LocalPort := txtPuerto.Text;
  wSocketEnviar.Connect;
  wSocketEnviar.SendStr('[' + txtNick.Text + '] ' + txtTexto.Text);
end;

procedure TformMenuPrincipal.wSocketEnviarDataSent(Sender: TObject;
  ErrCode: Word);
begin
  be.Panels[0].Text := 'Enviando datos';
  wSocketEnviar.Close;
end;

procedure TformMenuPrincipal.wSocketLeerDataAvailable(
    Sender: TObject; ErrCode: Word);
var
    Buffer : array [0..1023] of char;
    Len    : Integer;
    Src    : TSockAddrIn;
    SrcLen : Integer;
begin
  be.Panels[0].Text := 'Leyendo datos';
  SrcLen := SizeOf(Src);
  Len := wSocketLeer.ReceiveFrom(@Buffer,
      SizeOf(Buffer), Src, SrcLen);
  if Len >= 0 then
  begin
    if (FSenderAddr.S_addr = INADDR_ANY) or
        (FSenderAddr.S_addr = Src.Sin_addr.S_addr) then
    begin
      Buffer[Len] := #0;
      txtChat.Text := txtChat.Text + chr(13) + chr(10) +
           IntToStr(atoi(txtChat.Text) + 1) +
          '  ' + StrPas(inet_ntoa(Src.sin_addr)) +
          ':'  + IntToStr(ntohs(Src.sin_port)) +
          '--> ' + StrPas(Buffer);
   end;
 end;
end;

procedure TformMenuPrincipal.wSocketLeerSessionConnected(
    Sender: TObject; ErrCode: Word);
begin
  bActivarLeer.Enabled := false;
  bPararLeer.Enabled := true;
  be.Panels[0].Text := 'Conectado (lectura)';
end;

procedure TformMenuPrincipal.wSocketLeerSessionClosed(
    Sender: TObject; ErrCode: Word);
begin
  bActivarLeer.Enabled := True;
  bPararLeer.Enabled := false;
  be.Panels[0].Text := 'Desconectado (lectura)';
end;

procedure TformMenuPrincipal.bActivarLeerClick(
    Sender: TObject);
begin
  FSenderAddr := WSocketResolveHost('0.0.0.0');
  if FSenderAddr.S_addr = htonl(INADDR_LOOPBACK) then
    FSenderAddr := WSocketResolveHost(LocalHostName);
  wSocketLeer.Proto := 'udp';
  wSocketLeer.Addr := '0.0.0.0';
  wSocketLeer.Port := txtPuerto.Text;
  wSocketLeer.Listen;
end;

procedure TformMenuPrincipal.bPararLeerClick(Sender: TObject);
begin
  bActivarLeer.Enabled := true;
  bPararLeer.Enabled := false;
  wSocketLeer.Close;
end;

procedure TformMenuPrincipal.wSocketEnviarError(
    Sender: TObject);
begin
  be.Panels[0].Text := 'Error en envo';
end;

procedure TformMenuPrincipal.wSocketEnviarSessionConnected(
    Sender: TObject; ErrCode: Word);
begin
  be.Panels[0].Text := 'Conectado';
end;

end.
